#!/usr/bin/perl -w

use strict;
use Socket;

exit unless -f '/etc/rootdev';

my $rootdev = `cat /etc/rootdev`;
my ($ip) = $rootdev =~ /([\d\.]+):\//;
my $hostname = gethostbyaddr(inet_aton($ip), AF_INET) || 
	'dpo-unknown.eng.cam.ac.uk';
my ($nodename) = $hostname =~ /^(\w+)\./;

print "IP $ip Hostname $nodename\n";
open (SNAME, ">/etc/servername") or die "Can't write servername: !$\n";
print SNAME "$hostname\n";
close (SNAME);
